# coding: utf-8

# flake8: noqa

"""
    Phrase TMS API

    Welcome to Phrase's TMS API documentation.    Please visit our [help center](https://support.phrase.com/hc/en-us/sections/5709662083612) for more information about the APIs.    If you have any questions, please contact [Support](https://support.phrase.com/hc/requests/new).    Please, include the `User-Agent` header with the name of your application or project. It might be a good idea to include some sort of contact information as well, so that we can get in touch if necessary. Examples of excellent `User-Agent` headers:  > User-Agent: Example mobile app (example@phrase.com) <br/> User-Agent: ACME Inc Java 1.8 Client (http://acmeinc.com/contact)  # noqa: E501

    The version of the OpenAPI document: Latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


__version__ = "0.3.6"

# import apis into sdk package
from phrasetms_client.api.additional_workflow_step_api import AdditionalWorkflowStepApi
from phrasetms_client.api.analysis_api import AnalysisApi
from phrasetms_client.api.async_request_api import AsyncRequestApi
from phrasetms_client.api.authentication_api import AuthenticationApi
from phrasetms_client.api.bilingual_file_api import BilingualFileApi
from phrasetms_client.api.business_unit_api import BusinessUnitApi
from phrasetms_client.api.client_api import ClientApi
from phrasetms_client.api.connector_api import ConnectorApi
from phrasetms_client.api.conversations_api import ConversationsApi
from phrasetms_client.api.cost_center_api import CostCenterApi
from phrasetms_client.api.custom_fields_api import CustomFieldsApi
from phrasetms_client.api.custom_file_type_api import CustomFileTypeApi
from phrasetms_client.api.domain_api import DomainApi
from phrasetms_client.api.email_template_api import EmailTemplateApi
from phrasetms_client.api.file_api import FileApi
from phrasetms_client.api.glossary_api import GlossaryApi
from phrasetms_client.api.import_settings_api import ImportSettingsApi
from phrasetms_client.api.job_api import JobApi
from phrasetms_client.api.language_quality_assessment_api import (
    LanguageQualityAssessmentApi,
)
from phrasetms_client.api.machine_translation_api import MachineTranslationApi
from phrasetms_client.api.machine_translation_settings_api import (
    MachineTranslationSettingsApi,
)
from phrasetms_client.api.mapping_api import MappingApi
from phrasetms_client.api.net_rate_scheme_api import NetRateSchemeApi
from phrasetms_client.api.price_list_api import PriceListApi
from phrasetms_client.api.project_api import ProjectApi
from phrasetms_client.api.project_reference_file_api import ProjectReferenceFileApi
from phrasetms_client.api.project_template_api import ProjectTemplateApi
from phrasetms_client.api.provider_api import ProviderApi
from phrasetms_client.api.quality_assurance_api import QualityAssuranceApi
from phrasetms_client.api.quote_api import QuoteApi
from phrasetms_client.api.scim_api import SCIMApi
from phrasetms_client.api.segment_api import SegmentApi
from phrasetms_client.api.segmentation_rules_api import SegmentationRulesApi
from phrasetms_client.api.spell_check_api import SpellCheckApi
from phrasetms_client.api.sub_domain_api import SubDomainApi
from phrasetms_client.api.supported_languages_api import SupportedLanguagesApi
from phrasetms_client.api.term_base_api import TermBaseApi
from phrasetms_client.api.translation_api import TranslationApi
from phrasetms_client.api.translation_memory_api import TranslationMemoryApi
from phrasetms_client.api.user_api import UserApi
from phrasetms_client.api.vendor_api import VendorApi
from phrasetms_client.api.webhook_api import WebhookApi
from phrasetms_client.api.workflow_step_api import WorkflowStepApi
from phrasetms_client.api.workflow_changes_api import WorkflowChangesApi

# import ApiClient
from phrasetms_client.api_response import ApiResponse
from phrasetms_client.api_client import ApiClient
from phrasetms_client.configuration import Configuration
from phrasetms_client.exceptions import OpenApiException
from phrasetms_client.exceptions import ApiTypeError
from phrasetms_client.exceptions import ApiValueError
from phrasetms_client.exceptions import ApiKeyError
from phrasetms_client.exceptions import ApiAttributeError
from phrasetms_client.exceptions import ApiException

# import models into sdk package
from phrasetms_client.models.admin import ADMIN
from phrasetms_client.models.adminedit import ADMINEDIT
from phrasetms_client.models.adminresponse import ADMINRESPONSE
from phrasetms_client.models.absolute_translation_length_warning_dto import (
    AbsoluteTranslationLengthWarningDto,
)
from phrasetms_client.models.absolute_translation_length_warning_dto_all_of import (
    AbsoluteTranslationLengthWarningDtoAllOf,
)
from phrasetms_client.models.abstract_analyse_settings_dto import (
    AbstractAnalyseSettingsDto,
)
from phrasetms_client.models.abstract_connector_dto import AbstractConnectorDto
from phrasetms_client.models.abstract_project_dto import AbstractProjectDto
from phrasetms_client.models.abstract_project_dto_v2 import AbstractProjectDtoV2
from phrasetms_client.models.abstract_user_create_dto import AbstractUserCreateDto
from phrasetms_client.models.abstract_user_edit_dto import AbstractUserEditDto
from phrasetms_client.models.accuracy_weights_dto import AccuracyWeightsDto
from phrasetms_client.models.add_comment_dto import AddCommentDto
from phrasetms_client.models.add_lqa_comment_result_dto import AddLqaCommentResultDto
from phrasetms_client.models.add_plain_comment_result_dto import (
    AddPlainCommentResultDto,
)
from phrasetms_client.models.add_target_lang_dto import AddTargetLangDto
from phrasetms_client.models.add_workflow_steps_dto import AddWorkflowStepsDto
from phrasetms_client.models.additional_workflow_step_dto import (
    AdditionalWorkflowStepDto,
)
from phrasetms_client.models.additional_workflow_step_request_dto import (
    AdditionalWorkflowStepRequestDto,
)
from phrasetms_client.models.additional_workflow_step_v2_dto import (
    AdditionalWorkflowStepV2Dto,
)
from phrasetms_client.models.admin_project_manager import AdminProjectManager
from phrasetms_client.models.admin_project_manager_all_of import (
    AdminProjectManagerAllOf,
)
from phrasetms_client.models.admin_project_manager_v2 import AdminProjectManagerV2
from phrasetms_client.models.admin_project_manager_v2_all_of import (
    AdminProjectManagerV2AllOf,
)
from phrasetms_client.models.adobe_experience_manager import AdobeExperienceManager
from phrasetms_client.models.adobe_experience_manager_all_of import (
    AdobeExperienceManagerAllOf,
)
from phrasetms_client.models.amazon_s3 import AmazonS3
from phrasetms_client.models.amazon_s3_all_of import AmazonS3AllOf
from phrasetms_client.models.analyse_job_dto import AnalyseJobDto
from phrasetms_client.models.analyse_job_reference import AnalyseJobReference
from phrasetms_client.models.analyse_language_part_dto import AnalyseLanguagePartDto
from phrasetms_client.models.analyse_language_part_reference import (
    AnalyseLanguagePartReference,
)
from phrasetms_client.models.analyse_language_part_v2_dto import (
    AnalyseLanguagePartV2Dto,
)
from phrasetms_client.models.analyse_language_part_v3_dto import (
    AnalyseLanguagePartV3Dto,
)
from phrasetms_client.models.analyse_recalculate_request_dto import (
    AnalyseRecalculateRequestDto,
)
from phrasetms_client.models.analyse_recalculate_response_dto import (
    AnalyseRecalculateResponseDto,
)
from phrasetms_client.models.analyse_reference import AnalyseReference
from phrasetms_client.models.analyse_settings_dto import AnalyseSettingsDto
from phrasetms_client.models.analyse_v2_dto import AnalyseV2Dto
from phrasetms_client.models.analyse_v3_dto import AnalyseV3Dto
from phrasetms_client.models.analyses_v2_dto import AnalysesV2Dto
from phrasetms_client.models.android_settings_dto import AndroidSettingsDto
from phrasetms_client.models.apple_token_response_dto import AppleTokenResponseDto
from phrasetms_client.models.asciidoc_settings_dto import AsciidocSettingsDto
from phrasetms_client.models.assign_vendor_dto import AssignVendorDto
from phrasetms_client.models.assignable_templates_dto import AssignableTemplatesDto
from phrasetms_client.models.assigned_job_dto import AssignedJobDto
from phrasetms_client.models.assignment_per_target_lang_dto import (
    AssignmentPerTargetLangDto,
)
from phrasetms_client.models.async_analyse_list_response_dto import (
    AsyncAnalyseListResponseDto,
)
from phrasetms_client.models.async_analyse_list_response_v2_dto import (
    AsyncAnalyseListResponseV2Dto,
)
from phrasetms_client.models.async_analyse_response_dto import AsyncAnalyseResponseDto
from phrasetms_client.models.async_analyse_response_v2_dto import (
    AsyncAnalyseResponseV2Dto,
)
from phrasetms_client.models.async_export_tmby_query_dto import AsyncExportTMByQueryDto
from phrasetms_client.models.async_export_tmby_query_response_dto import (
    AsyncExportTMByQueryResponseDto,
)
from phrasetms_client.models.async_export_tm_dto import AsyncExportTMDto
from phrasetms_client.models.async_export_tm_response_dto import (
    AsyncExportTMResponseDto,
)
from phrasetms_client.models.async_file_op_response_dto import AsyncFileOpResponseDto
from phrasetms_client.models.async_request_dto import AsyncRequestDto
from phrasetms_client.models.async_request_reference import AsyncRequestReference
from phrasetms_client.models.async_request_status_dto import AsyncRequestStatusDto
from phrasetms_client.models.async_request_v2_dto import AsyncRequestV2Dto
from phrasetms_client.models.async_request_wrapper_dto import AsyncRequestWrapperDto
from phrasetms_client.models.async_request_wrapper_v2_dto import (
    AsyncRequestWrapperV2Dto,
)
from phrasetms_client.models.async_response_dto import AsyncResponseDto
from phrasetms_client.models.async_response_v2_dto import AsyncResponseV2Dto
from phrasetms_client.models.attribute import Attribute
from phrasetms_client.models.auth_schema import AuthSchema
from phrasetms_client.models.automated_project_settings_dto import (
    AutomatedProjectSettingsDto,
)
from phrasetms_client.models.background_tasks_tb_dto import BackgroundTasksTbDto
from phrasetms_client.models.background_tasks_tm_dto import BackgroundTasksTmDto
from phrasetms_client.models.bitbucket_server import BitbucketServer
from phrasetms_client.models.bitbucket_server_all_of import BitbucketServerAllOf
from phrasetms_client.models.browse_request_dto import BrowseRequestDto
from phrasetms_client.models.browse_response_list_dto import BrowseResponseListDto
from phrasetms_client.models.bulk_delete_analyse_dto import BulkDeleteAnalyseDto
from phrasetms_client.models.bulk_edit_analyse_v2_dto import BulkEditAnalyseV2Dto
from phrasetms_client.models.business_unit_dto import BusinessUnitDto
from phrasetms_client.models.business_unit_edit_dto import BusinessUnitEditDto
from phrasetms_client.models.business_unit_reference import BusinessUnitReference
from phrasetms_client.models.buyer import Buyer
from phrasetms_client.models.buyer_all_of import BuyerAllOf
from phrasetms_client.models.buyer_reference import BuyerReference
from phrasetms_client.models.check_response import CheckResponse
from phrasetms_client.models.cleaned_trans_memories_dto import CleanedTransMemoriesDto
from phrasetms_client.models.client_dto import ClientDto
from phrasetms_client.models.client_edit_dto import ClientEditDto
from phrasetms_client.models.client_reference import ClientReference
from phrasetms_client.models.clone_project_dto import CloneProjectDto
from phrasetms_client.models.comment_dto import CommentDto
from phrasetms_client.models.common_conversation_dto import CommonConversationDto
from phrasetms_client.models.compared_segment_dto import ComparedSegmentDto
from phrasetms_client.models.compared_segments_dto import ComparedSegmentsDto
from phrasetms_client.models.concept_dto import ConceptDto
from phrasetms_client.models.concept_dtov2 import ConceptDtov2
from phrasetms_client.models.concept_edit_dto import ConceptEditDto
from phrasetms_client.models.concept_list_reference import ConceptListReference
from phrasetms_client.models.concept_list_response_dto import ConceptListResponseDto
from phrasetms_client.models.concept_with_metadata_dto import ConceptWithMetadataDto
from phrasetms_client.models.concurrent_requests_dto import ConcurrentRequestsDto
from phrasetms_client.models.connector_create_response_dto import (
    ConnectorCreateResponseDto,
)
from phrasetms_client.models.connector_dto import ConnectorDto
from phrasetms_client.models.connector_error_detail_dto import ConnectorErrorDetailDto
from phrasetms_client.models.connector_errors_dto import ConnectorErrorsDto
from phrasetms_client.models.connector_list_dto import ConnectorListDto
from phrasetms_client.models.contentstack import Contentstack
from phrasetms_client.models.contentstack_all_of import ContentstackAllOf
from phrasetms_client.models.continuous_job_info_dto import ContinuousJobInfoDto
from phrasetms_client.models.conversation_list_dto import ConversationListDto
from phrasetms_client.models.cost_center_dto import CostCenterDto
from phrasetms_client.models.cost_center_edit_dto import CostCenterEditDto
from phrasetms_client.models.cost_center_reference import CostCenterReference
from phrasetms_client.models.counts_dto import CountsDto
from phrasetms_client.models.create_analyse_async_v2_dto import CreateAnalyseAsyncV2Dto
from phrasetms_client.models.create_analyse_list_async_dto import (
    CreateAnalyseListAsyncDto,
)
from phrasetms_client.models.create_custom_field_dto import CreateCustomFieldDto
from phrasetms_client.models.create_custom_field_instance_dto import (
    CreateCustomFieldInstanceDto,
)
from phrasetms_client.models.create_custom_field_instances_dto import (
    CreateCustomFieldInstancesDto,
)
from phrasetms_client.models.create_custom_file_type_dto import CreateCustomFileTypeDto
from phrasetms_client.models.create_lqa_conversation_dto import CreateLqaConversationDto
from phrasetms_client.models.create_lqa_profile_dto import CreateLqaProfileDto
from phrasetms_client.models.create_plain_conversation_dto import (
    CreatePlainConversationDto,
)
from phrasetms_client.models.create_project_from_template_async_v2_dto import (
    CreateProjectFromTemplateAsyncV2Dto,
)
from phrasetms_client.models.create_project_from_template_v2_dto import (
    CreateProjectFromTemplateV2Dto,
)
from phrasetms_client.models.create_project_v3_dto import CreateProjectV3Dto
from phrasetms_client.models.create_reference_file_note_dto import (
    CreateReferenceFileNoteDto,
)
from phrasetms_client.models.create_terms_dto import CreateTermsDto
from phrasetms_client.models.create_vendor_dto import CreateVendorDto
from phrasetms_client.models.create_web_editor_link_dto_v2 import (
    CreateWebEditorLinkDtoV2,
)
from phrasetms_client.models.create_web_hook_dto import CreateWebHookDto
from phrasetms_client.models.create_workflow_step_dto import CreateWorkflowStepDto
from phrasetms_client.models.csv_settings_dto import CsvSettingsDto
from phrasetms_client.models.custom_field_dto import CustomFieldDto
from phrasetms_client.models.custom_field_instance_api_dto import (
    CustomFieldInstanceApiDto,
)
from phrasetms_client.models.custom_field_instance_dto import CustomFieldInstanceDto
from phrasetms_client.models.custom_field_instances_dto import CustomFieldInstancesDto
from phrasetms_client.models.custom_field_option_dto import CustomFieldOptionDto
from phrasetms_client.models.custom_field_options_truncated_dto import (
    CustomFieldOptionsTruncatedDto,
)
from phrasetms_client.models.custom_file_type_dto import CustomFileTypeDto
from phrasetms_client.models.custom_qa_warning_dto import CustomQAWarningDto
from phrasetms_client.models.custom_qa_warning_dto_all_of import CustomQAWarningDtoAllOf
from phrasetms_client.models.data_dto import DataDto
from phrasetms_client.models.data_dto_v1 import DataDtoV1
from phrasetms_client.models.delete_custom_file_type_dto import DeleteCustomFileTypeDto
from phrasetms_client.models.design_weights_dto import DesignWeightsDto
from phrasetms_client.models.dictionary_item_dto import DictionaryItemDto
from phrasetms_client.models.discount_scheme_create_dto import DiscountSchemeCreateDto
from phrasetms_client.models.discount_scheme_reference import DiscountSchemeReference
from phrasetms_client.models.discount_settings_dto import DiscountSettingsDto
from phrasetms_client.models.dita_settings_dto import DitaSettingsDto
from phrasetms_client.models.doc_book_settings_dto import DocBookSettingsDto
from phrasetms_client.models.doc_settings_dto import DocSettingsDto
from phrasetms_client.models.domain_dto import DomainDto
from phrasetms_client.models.domain_edit_dto import DomainEditDto
from phrasetms_client.models.domain_reference import DomainReference
from phrasetms_client.models.edit_analyse_settings_dto import EditAnalyseSettingsDto
from phrasetms_client.models.edit_analyse_v2_dto import EditAnalyseV2Dto
from phrasetms_client.models.edit_lqa_conversation_dto import EditLqaConversationDto
from phrasetms_client.models.edit_plain_conversation_dto import EditPlainConversationDto
from phrasetms_client.models.edit_project_mt_sett_per_lang_dto import (
    EditProjectMTSettPerLangDto,
)
from phrasetms_client.models.edit_project_mt_sett_per_lang_list_dto import (
    EditProjectMTSettPerLangListDto,
)
from phrasetms_client.models.edit_project_mt_settings_dto import (
    EditProjectMTSettingsDto,
)
from phrasetms_client.models.edit_project_security_settings_dto_v2 import (
    EditProjectSecuritySettingsDtoV2,
)
from phrasetms_client.models.edit_project_v2_dto import EditProjectV2Dto
from phrasetms_client.models.edit_qa_settings_dto_v2 import EditQASettingsDtoV2
from phrasetms_client.models.edit_segmentation_rule_dto import EditSegmentationRuleDto
from phrasetms_client.models.edit_workflow_step_dto import EditWorkflowStepDto
from phrasetms_client.models.edition_dto import EditionDto
from phrasetms_client.models.email import Email
from phrasetms_client.models.email_quotes_request_dto import EmailQuotesRequestDto
from phrasetms_client.models.email_quotes_response_dto import EmailQuotesResponseDto
from phrasetms_client.models.empty_pair_tags_warning_dto import EmptyPairTagsWarningDto
from phrasetms_client.models.empty_tag_content_warning_dto import (
    EmptyTagContentWarningDto,
)
from phrasetms_client.models.empty_translation_warning_dto import (
    EmptyTranslationWarningDto,
)
from phrasetms_client.models.enabled_check_context_dto_v2 import (
    EnabledCheckContextDtoV2,
)
from phrasetms_client.models.enabled_check_dto_v2 import EnabledCheckDtoV2
from phrasetms_client.models.enabled_quality_checks_dto import EnabledQualityChecksDto
from phrasetms_client.models.error_categories_dto import ErrorCategoriesDto
from phrasetms_client.models.error_detail_dto import ErrorDetailDto
from phrasetms_client.models.error_detail_dto_v2 import ErrorDetailDtoV2
from phrasetms_client.models.error_detail_dto_v3 import ErrorDetailDtoV3
from phrasetms_client.models.error_dto import ErrorDto
from phrasetms_client.models.export_by_query_dto import ExportByQueryDto
from phrasetms_client.models.export_tm_dto import ExportTMDto
from phrasetms_client.models.extra_numbers_v3_warning_dto import (
    ExtraNumbersV3WarningDto,
)
from phrasetms_client.models.extra_numbers_v3_warning_dto_all_of import (
    ExtraNumbersV3WarningDtoAllOf,
)
from phrasetms_client.models.extra_numbers_warning_dto import ExtraNumbersWarningDto
from phrasetms_client.models.extra_numbers_warning_dto_all_of import (
    ExtraNumbersWarningDtoAllOf,
)
from phrasetms_client.models.features_dto import FeaturesDto
from phrasetms_client.models.file_dto import FileDto
from phrasetms_client.models.file_handover_dto import FileHandoverDto
from phrasetms_client.models.file_import_settings_create_dto import (
    FileImportSettingsCreateDto,
)
from phrasetms_client.models.file_import_settings_dto import FileImportSettingsDto
from phrasetms_client.models.file_list_dto import FileListDto
from phrasetms_client.models.file_naming_settings_dto import FileNamingSettingsDto
from phrasetms_client.models.financial_settings_dto import FinancialSettingsDto
from phrasetms_client.models.find_conversations_dto import FindConversationsDto
from phrasetms_client.models.fluency_weights_dto import FluencyWeightsDto
from phrasetms_client.models.forbidden_string_warning_dto import (
    ForbiddenStringWarningDto,
)
from phrasetms_client.models.forbidden_string_warning_dto_all_of import (
    ForbiddenStringWarningDtoAllOf,
)
from phrasetms_client.models.forbidden_term_warning_dto import ForbiddenTermWarningDto
from phrasetms_client.models.forbidden_term_warning_dto_all_of import (
    ForbiddenTermWarningDtoAllOf,
)
from phrasetms_client.models.formatting_warning_dto import FormattingWarningDto
from phrasetms_client.models.ftp import Ftp
from phrasetms_client.models.ftp_all_of import FtpAllOf
from phrasetms_client.models.fuzzy_inconsistency_warning_dto import (
    FuzzyInconsistencyWarningDto,
)
from phrasetms_client.models.fuzzy_inconsistency_warning_dto_all_of import (
    FuzzyInconsistencyWarningDtoAllOf,
)
from phrasetms_client.models.guest import GUEST
from phrasetms_client.models.guestedit import GUESTEDIT
from phrasetms_client.models.guestedit_all_of import GUESTEDITAllOf
from phrasetms_client.models.guestresponse import GUESTRESPONSE
from phrasetms_client.models.guestresponse_all_of import GUESTRESPONSEAllOf
from phrasetms_client.models.get_bilingual_file_dto import GetBilingualFileDto
from phrasetms_client.models.get_file_request_params_dto import GetFileRequestParamsDto
from phrasetms_client.models.git import Git
from phrasetms_client.models.git_all_of import GitAllOf
from phrasetms_client.models.git_lab import GitLab
from phrasetms_client.models.git_lab_all_of import GitLabAllOf
from phrasetms_client.models.glossary_activation_dto import GlossaryActivationDto
from phrasetms_client.models.glossary_dto import GlossaryDto
from phrasetms_client.models.glossary_edit_dto import GlossaryEditDto
from phrasetms_client.models.html_settings_dto import HtmlSettingsDto
from phrasetms_client.models.human_translate_jobs_dto import HumanTranslateJobsDto
from phrasetms_client.models.id_reference import IdReference
from phrasetms_client.models.idml_settings_dto import IdmlSettingsDto
from phrasetms_client.models.import_settings_create_dto import ImportSettingsCreateDto
from phrasetms_client.models.import_settings_dto import ImportSettingsDto
from phrasetms_client.models.import_settings_edit_dto import ImportSettingsEditDto
from phrasetms_client.models.import_settings_reference import ImportSettingsReference
from phrasetms_client.models.import_status_dto import ImportStatusDto
from phrasetms_client.models.import_status_dto_v2 import ImportStatusDtoV2
from phrasetms_client.models.import_term_base_response_dto import (
    ImportTermBaseResponseDto,
)
from phrasetms_client.models.inconsistent_tag_content_warning_dto import (
    InconsistentTagContentWarningDto,
)
from phrasetms_client.models.inconsistent_translation_warning_dto import (
    InconsistentTranslationWarningDto,
)
from phrasetms_client.models.inconsistent_translation_warning_dto_all_of import (
    InconsistentTranslationWarningDtoAllOf,
)
from phrasetms_client.models.input_stream_length import InputStreamLength
from phrasetms_client.models.job_create_remote_file_dto import JobCreateRemoteFileDto
from phrasetms_client.models.job_create_request_dto import JobCreateRequestDto
from phrasetms_client.models.job_export_action_dto import JobExportActionDto
from phrasetms_client.models.job_export_response_dto import JobExportResponseDto
from phrasetms_client.models.job_list_dto import JobListDto
from phrasetms_client.models.job_machine_translation_settings_dto import (
    JobMachineTranslationSettingsDto,
)
from phrasetms_client.models.job_non_translatable_settings_dto import (
    JobNonTranslatableSettingsDto,
)
from phrasetms_client.models.job_part_delete_references import JobPartDeleteReferences
from phrasetms_client.models.job_part_extended_dto import JobPartExtendedDto
from phrasetms_client.models.job_part_patch_batch_dto import JobPartPatchBatchDto
from phrasetms_client.models.job_part_patch_result_dto import JobPartPatchResultDto
from phrasetms_client.models.job_part_patch_single_dto import JobPartPatchSingleDto
from phrasetms_client.models.job_part_ready_delete_translation_dto import (
    JobPartReadyDeleteTranslationDto,
)
from phrasetms_client.models.job_part_ready_delete_translation_filter_dto import (
    JobPartReadyDeleteTranslationFilterDto,
)
from phrasetms_client.models.job_part_ready_references import JobPartReadyReferences
from phrasetms_client.models.job_part_reference import JobPartReference
from phrasetms_client.models.job_part_reference_v2 import JobPartReferenceV2
from phrasetms_client.models.job_part_references import JobPartReferences
from phrasetms_client.models.job_part_segments_dto_v3 import JobPartSegmentsDtoV3
from phrasetms_client.models.job_part_status_change_dto import JobPartStatusChangeDto
from phrasetms_client.models.job_part_status_changes_dto import JobPartStatusChangesDto
from phrasetms_client.models.job_part_update_batch_dto import JobPartUpdateBatchDto
from phrasetms_client.models.job_part_update_single_dto import JobPartUpdateSingleDto
from phrasetms_client.models.job_part_update_source_dto import JobPartUpdateSourceDto
from phrasetms_client.models.job_parts_dto import JobPartsDto
from phrasetms_client.models.job_reference import JobReference
from phrasetms_client.models.job_role_dto import JobRoleDto
from phrasetms_client.models.job_segment_dto import JobSegmentDto
from phrasetms_client.models.job_status_change_action_dto import (
    JobStatusChangeActionDto,
)
from phrasetms_client.models.job_translation_memory_settings_dto import (
    JobTranslationMemorySettingsDto,
)
from phrasetms_client.models.job_update_source_response_dto import (
    JobUpdateSourceResponseDto,
)
from phrasetms_client.models.join_tags_warning_dto import JoinTagsWarningDto
from phrasetms_client.models.join_tags_warning_dto_all_of import JoinTagsWarningDtoAllOf
from phrasetms_client.models.joomla import Joomla
from phrasetms_client.models.joomla_all_of import JoomlaAllOf
from phrasetms_client.models.json_settings_dto import JsonSettingsDto
from phrasetms_client.models.kentico import Kentico
from phrasetms_client.models.kentico_all_of import KenticoAllOf
from phrasetms_client.models.linguist_ import LINGUIST
from phrasetms_client.models.linguistedit import LINGUISTEDIT
from phrasetms_client.models.linguistedit_all_of import LINGUISTEDITAllOf
from phrasetms_client.models.linguistresponse import LINGUISTRESPONSE
from phrasetms_client.models.linguistresponse_all_of import LINGUISTRESPONSEAllOf
from phrasetms_client.models.lqa import LQA
from phrasetms_client.models.lqa_all_of import LQAAllOf
from phrasetms_client.models.lqa_conversation_dto import LQAConversationDto
from phrasetms_client.models.lqa_conversations_list_dto import LQAConversationsListDto
from phrasetms_client.models.lqa_reference import LQAReference
from phrasetms_client.models.lqa_references import LQAReferences
from phrasetms_client.models.language_dto import LanguageDto
from phrasetms_client.models.language_list_dto import LanguageListDto
from phrasetms_client.models.language_metadata1 import LanguageMetadata1
from phrasetms_client.models.last_login_dto import LastLoginDto
from phrasetms_client.models.leading_and_trailing_spaces_warning_dto import (
    LeadingAndTrailingSpacesWarningDto,
)
from phrasetms_client.models.leading_and_trailing_spaces_warning_dto_all_of import (
    LeadingAndTrailingSpacesWarningDtoAllOf,
)
from phrasetms_client.models.linguist import Linguist
from phrasetms_client.models.linguist_v2 import LinguistV2
from phrasetms_client.models.locale_convention_weights_dto import (
    LocaleConventionWeightsDto,
)
from phrasetms_client.models.login_dto import LoginDto
from phrasetms_client.models.login_other_dto import LoginOtherDto
from phrasetms_client.models.login_other_v3_dto import LoginOtherV3Dto
from phrasetms_client.models.login_response_dto import LoginResponseDto
from phrasetms_client.models.login_response_v3_dto import LoginResponseV3Dto
from phrasetms_client.models.login_to_session_dto import LoginToSessionDto
from phrasetms_client.models.login_to_session_response_dto import (
    LoginToSessionResponseDto,
)
from phrasetms_client.models.login_to_session_response_v3_dto import (
    LoginToSessionResponseV3Dto,
)
from phrasetms_client.models.login_to_session_v3_dto import LoginToSessionV3Dto
from phrasetms_client.models.login_user_dto import LoginUserDto
from phrasetms_client.models.login_v3_dto import LoginV3Dto
from phrasetms_client.models.login_with_apple_dto import LoginWithAppleDto
from phrasetms_client.models.login_with_google_dto import LoginWithGoogleDto
from phrasetms_client.models.lqa_error_category_dto import LqaErrorCategoryDto
from phrasetms_client.models.lqa_profile_detail_dto import LqaProfileDetailDto
from phrasetms_client.models.lqa_profile_reference_dto import LqaProfileReferenceDto
from phrasetms_client.models.lqa_profiles_for_ws_v2_dto import LqaProfilesForWsV2Dto
from phrasetms_client.models.lqa_settings_dto import LqaSettingsDto
from phrasetms_client.models.lqa_severity_dto import LqaSeverityDto
from phrasetms_client.models.moravia import MORAVIA
from phrasetms_client.models.moravia_all_of import MORAVIAAllOf
from phrasetms_client.models.mt_settings_per_language_dto import (
    MTSettingsPerLanguageDto,
)
from phrasetms_client.models.mt_settings_per_language_list_dto import (
    MTSettingsPerLanguageListDto,
)
from phrasetms_client.models.mt_settings_per_language_reference import (
    MTSettingsPerLanguageReference,
)
from phrasetms_client.models.mac_settings_dto import MacSettingsDto
from phrasetms_client.models.machine_translate_response import MachineTranslateResponse
from phrasetms_client.models.machine_translate_settings_dto import (
    MachineTranslateSettingsDto,
)
from phrasetms_client.models.machine_translate_settings_langs_dto import (
    MachineTranslateSettingsLangsDto,
)
from phrasetms_client.models.machine_translate_settings_pbm_dto import (
    MachineTranslateSettingsPbmDto,
)
from phrasetms_client.models.machine_translate_settings_reference import (
    MachineTranslateSettingsReference,
)
from phrasetms_client.models.machine_translate_status_dto import (
    MachineTranslateStatusDto,
)
from phrasetms_client.models.machine_translation_settings_dto import (
    MachineTranslationSettingsDto,
)
from phrasetms_client.models.magento import Magento
from phrasetms_client.models.malformed_warning_dto import MalformedWarningDto
from phrasetms_client.models.malformed_warning_dto_all_of import (
    MalformedWarningDtoAllOf,
)
from phrasetms_client.models.marketo import Marketo
from phrasetms_client.models.marketo_all_of import MarketoAllOf
from phrasetms_client.models.marketo_segment_mapping_dto import MarketoSegmentMappingDto
from phrasetms_client.models.marketo_segmentation_mapping_dto import (
    MarketoSegmentationMappingDto,
)
from phrasetms_client.models.match import Match
from phrasetms_client.models.match_counts101_dto import MatchCounts101Dto
from phrasetms_client.models.match_counts_dto import MatchCountsDto
from phrasetms_client.models.match_counts_nt_dto import MatchCountsNTDto
from phrasetms_client.models.match_counts_nt_dto_v1 import MatchCountsNTDtoV1
from phrasetms_client.models.md_settings_dto import MdSettingsDto
from phrasetms_client.models.mem_trans_machine_translate_settings_dto import (
    MemTransMachineTranslateSettingsDto,
)
from phrasetms_client.models.memsource_translate_profile_simple_dto import (
    MemsourceTranslateProfileSimpleDto,
)
from phrasetms_client.models.mention_dto import MentionDto
from phrasetms_client.models.mentionable_group_dto import MentionableGroupDto
from phrasetms_client.models.mentionable_user_dto import MentionableUserDto
from phrasetms_client.models.metadata_field import MetadataField
from phrasetms_client.models.metadata_option_reference import MetadataOptionReference
from phrasetms_client.models.metadata_priority_settings_dto import (
    MetadataPrioritySettingsDto,
)
from phrasetms_client.models.metadata_reference import MetadataReference
from phrasetms_client.models.metadata_response import MetadataResponse
from phrasetms_client.models.metadata_tb_dto import MetadataTbDto
from phrasetms_client.models.microsoft_azure import MicrosoftAzure
from phrasetms_client.models.microsoft_azure_all_of import MicrosoftAzureAllOf
from phrasetms_client.models.mif_settings_dto import MifSettingsDto
from phrasetms_client.models.missing_numbers_v3_warning_dto import (
    MissingNumbersV3WarningDto,
)
from phrasetms_client.models.missing_numbers_warning_dto import MissingNumbersWarningDto
from phrasetms_client.models.missing_numbers_warning_dto_all_of import (
    MissingNumbersWarningDtoAllOf,
)
from phrasetms_client.models.misspelled_word import MisspelledWord
from phrasetms_client.models.misspelled_word_dto import MisspelledWordDto
from phrasetms_client.models.moravia_warning_dto import MoraviaWarningDto
from phrasetms_client.models.moravia_warning_dto_all_of import MoraviaWarningDtoAllOf
from phrasetms_client.models.multilingual_csv_settings_dto import (
    MultilingualCsvSettingsDto,
)
from phrasetms_client.models.multilingual_xls_settings_dto import (
    MultilingualXlsSettingsDto,
)
from phrasetms_client.models.multilingual_xml_settings_dto import (
    MultilingualXmlSettingsDto,
)
from phrasetms_client.models.multiple_spaces_v3_warning_dto import (
    MultipleSpacesV3WarningDto,
)
from phrasetms_client.models.multiple_spaces_v3_warning_dto_all_of import (
    MultipleSpacesV3WarningDtoAllOf,
)
from phrasetms_client.models.multiple_spaces_warning_dto import MultipleSpacesWarningDto
from phrasetms_client.models.number import NUMBER
from phrasetms_client.models.number_all_of import NUMBERAllOf
from phrasetms_client.models.name import Name
from phrasetms_client.models.name_dto import NameDto
from phrasetms_client.models.nested_tags_warning_dto import NestedTagsWarningDto
from phrasetms_client.models.nested_tags_warning_dto_all_of import (
    NestedTagsWarningDtoAllOf,
)
from phrasetms_client.models.net_rate_scheme import NetRateScheme
from phrasetms_client.models.net_rate_scheme_edit import NetRateSchemeEdit
from phrasetms_client.models.net_rate_scheme_reference import NetRateSchemeReference
from phrasetms_client.models.net_rate_scheme_workflow_step import (
    NetRateSchemeWorkflowStep,
)
from phrasetms_client.models.net_rate_scheme_workflow_step_create import (
    NetRateSchemeWorkflowStepCreate,
)
from phrasetms_client.models.net_rate_scheme_workflow_step_edit import (
    NetRateSchemeWorkflowStepEdit,
)
from phrasetms_client.models.net_rate_scheme_workflow_step_reference import (
    NetRateSchemeWorkflowStepReference,
)
from phrasetms_client.models.newer_at_lower_level_warning_dto import (
    NewerAtLowerLevelWarningDto,
)
from phrasetms_client.models.non_conforming_term_warning_dto import (
    NonConformingTermWarningDto,
)
from phrasetms_client.models.non_conforming_term_warning_dto_all_of import (
    NonConformingTermWarningDtoAllOf,
)
from phrasetms_client.models.non_translatable_settings_dto import (
    NonTranslatableSettingsDto,
)
from phrasetms_client.models.not_confirmed_warning_dto import NotConfirmedWarningDto
from phrasetms_client.models.notify_job_parts_request_dto import (
    NotifyJobPartsRequestDto,
)
from phrasetms_client.models.notify_provider_dto import NotifyProviderDto
from phrasetms_client.models.organization_email_template_dto import (
    OrganizationEmailTemplateDto,
)
from phrasetms_client.models.organization_reference import OrganizationReference
from phrasetms_client.models.other_weights_dto import OtherWeightsDto
from phrasetms_client.models.projectmanager import PROJECTMANAGER
from phrasetms_client.models.projectmanageredit import PROJECTMANAGEREDIT
from phrasetms_client.models.projectmanageredit_all_of import PROJECTMANAGEREDITAllOf
from phrasetms_client.models.projectmanagerresponse import PROJECTMANAGERRESPONSE
from phrasetms_client.models.projectmanagerresponse_all_of import (
    PROJECTMANAGERRESPONSEAllOf,
)
from phrasetms_client.models.page_dto_abstract_project_dto import (
    PageDtoAbstractProjectDto,
)
from phrasetms_client.models.page_dto_additional_workflow_step_dto import (
    PageDtoAdditionalWorkflowStepDto,
)
from phrasetms_client.models.page_dto_analyse_job_dto import PageDtoAnalyseJobDto
from phrasetms_client.models.page_dto_analyse_reference import PageDtoAnalyseReference
from phrasetms_client.models.page_dto_assigned_job_dto import PageDtoAssignedJobDto
from phrasetms_client.models.page_dto_async_request_dto import PageDtoAsyncRequestDto
from phrasetms_client.models.page_dto_business_unit_dto import PageDtoBusinessUnitDto
from phrasetms_client.models.page_dto_client_dto import PageDtoClientDto
from phrasetms_client.models.page_dto_cost_center_dto import PageDtoCostCenterDto
from phrasetms_client.models.page_dto_custom_field_dto import PageDtoCustomFieldDto
from phrasetms_client.models.page_dto_custom_field_instance_dto import (
    PageDtoCustomFieldInstanceDto,
)
from phrasetms_client.models.page_dto_custom_field_option_dto import (
    PageDtoCustomFieldOptionDto,
)
from phrasetms_client.models.page_dto_custom_file_type_dto import (
    PageDtoCustomFileTypeDto,
)
from phrasetms_client.models.page_dto_domain_dto import PageDtoDomainDto
from phrasetms_client.models.page_dto_glossary_dto import PageDtoGlossaryDto
from phrasetms_client.models.page_dto_import_settings_reference import (
    PageDtoImportSettingsReference,
)
from phrasetms_client.models.page_dto_job_part_reference_v2 import (
    PageDtoJobPartReferenceV2,
)
from phrasetms_client.models.page_dto_last_login_dto import PageDtoLastLoginDto
from phrasetms_client.models.page_dto_lqa_profile_reference_dto import (
    PageDtoLqaProfileReferenceDto,
)
from phrasetms_client.models.page_dto_machine_translate_settings_pbm_dto import (
    PageDtoMachineTranslateSettingsPbmDto,
)
from phrasetms_client.models.page_dto_net_rate_scheme_reference import (
    PageDtoNetRateSchemeReference,
)
from phrasetms_client.models.page_dto_net_rate_scheme_workflow_step_reference import (
    PageDtoNetRateSchemeWorkflowStepReference,
)
from phrasetms_client.models.page_dto_organization_email_template_dto import (
    PageDtoOrganizationEmailTemplateDto,
)
from phrasetms_client.models.page_dto_project_reference import PageDtoProjectReference
from phrasetms_client.models.page_dto_project_template_reference import (
    PageDtoProjectTemplateReference,
)
from phrasetms_client.models.page_dto_provider_reference import PageDtoProviderReference
from phrasetms_client.models.page_dto_quote_dto import PageDtoQuoteDto
from phrasetms_client.models.page_dto_segmentation_rule_reference import (
    PageDtoSegmentationRuleReference,
)
from phrasetms_client.models.page_dto_string import PageDtoString
from phrasetms_client.models.page_dto_sub_domain_dto import PageDtoSubDomainDto
from phrasetms_client.models.page_dto_term_base_dto import PageDtoTermBaseDto
from phrasetms_client.models.page_dto_trans_memory_dto import PageDtoTransMemoryDto
from phrasetms_client.models.page_dto_translation_price_list_dto import (
    PageDtoTranslationPriceListDto,
)
from phrasetms_client.models.page_dto_translation_price_set_dto import (
    PageDtoTranslationPriceSetDto,
)
from phrasetms_client.models.page_dto_uploaded_file_dto import PageDtoUploadedFileDto
from phrasetms_client.models.page_dto_user_dto import PageDtoUserDto
from phrasetms_client.models.page_dto_vendor_dto import PageDtoVendorDto
from phrasetms_client.models.page_dto_web_hook_dto_v2 import PageDtoWebHookDtoV2
from phrasetms_client.models.page_dto_webhook_call_dto import PageDtoWebhookCallDto
from phrasetms_client.models.page_dto_workflow_step_dto import PageDtoWorkflowStepDto
from phrasetms_client.models.page_dto_workflow_step_reference import (
    PageDtoWorkflowStepReference,
)
from phrasetms_client.models.pass_fail_threshold_dto import PassFailThresholdDto
from phrasetms_client.models.patch_project_dto import PatchProjectDto
from phrasetms_client.models.pdf_settings_dto import PdfSettingsDto
from phrasetms_client.models.penalty_points_dto import PenaltyPointsDto
from phrasetms_client.models.php_settings_dto import PhpSettingsDto
from phrasetms_client.models.plain_conversation_dto import PlainConversationDto
from phrasetms_client.models.plain_conversations_list_dto import (
    PlainConversationsListDto,
)
from phrasetms_client.models.plain_references import PlainReferences
from phrasetms_client.models.po_settings_dto import PoSettingsDto
from phrasetms_client.models.position import Position
from phrasetms_client.models.post_analyse import PostAnalyse
from phrasetms_client.models.post_analyse_all_of import PostAnalyseAllOf
from phrasetms_client.models.ppt_settings_dto import PptSettingsDto
from phrasetms_client.models.pre_analyse import PreAnalyse
from phrasetms_client.models.pre_analyse_all_of import PreAnalyseAllOf
from phrasetms_client.models.pre_analyse_target_compare import PreAnalyseTargetCompare
from phrasetms_client.models.pre_analyse_target_compare_all_of import (
    PreAnalyseTargetCompareAllOf,
)
from phrasetms_client.models.pre_translate_job_settings_dto import (
    PreTranslateJobSettingsDto,
)
from phrasetms_client.models.pre_translate_jobs_v2_dto import PreTranslateJobsV2Dto
from phrasetms_client.models.pre_translate_settings_v3_dto import (
    PreTranslateSettingsV3Dto,
)
from phrasetms_client.models.preview_url_dto import PreviewUrlDto
from phrasetms_client.models.preview_urls_dto import PreviewUrlsDto
from phrasetms_client.models.previous_workflow_dto import PreviousWorkflowDto
from phrasetms_client.models.price_list_reference import PriceListReference
from phrasetms_client.models.progress_dto import ProgressDto
from phrasetms_client.models.progress_dto_v2 import ProgressDtoV2
from phrasetms_client.models.progress_reference import ProgressReference
from phrasetms_client.models.project_mt_settings_per_lang_dto import (
    ProjectMTSettingsPerLangDto,
)
from phrasetms_client.models.project_reference import ProjectReference
from phrasetms_client.models.project_reference_files_request_dto import (
    ProjectReferenceFilesRequestDto,
)
from phrasetms_client.models.project_security_settings_dto_v2 import (
    ProjectSecuritySettingsDtoV2,
)
from phrasetms_client.models.project_template_create_action_dto import (
    ProjectTemplateCreateActionDto,
)
from phrasetms_client.models.project_template_dto import ProjectTemplateDto
from phrasetms_client.models.project_template_edit_dto import ProjectTemplateEditDto
from phrasetms_client.models.project_template_notify_provider_dto import (
    ProjectTemplateNotifyProviderDto,
)
from phrasetms_client.models.project_template_reference import ProjectTemplateReference
from phrasetms_client.models.project_template_term_base_dto import (
    ProjectTemplateTermBaseDto,
)
from phrasetms_client.models.project_template_term_base_list_dto import (
    ProjectTemplateTermBaseListDto,
)
from phrasetms_client.models.project_template_trans_memory_dto_v3 import (
    ProjectTemplateTransMemoryDtoV3,
)
from phrasetms_client.models.project_template_trans_memory_list_dto_v3 import (
    ProjectTemplateTransMemoryListDtoV3,
)
from phrasetms_client.models.project_template_trans_memory_list_v2_dto import (
    ProjectTemplateTransMemoryListV2Dto,
)
from phrasetms_client.models.project_template_trans_memory_v2_dto import (
    ProjectTemplateTransMemoryV2Dto,
)
from phrasetms_client.models.project_template_workflow_settings_assigned_to_dto import (
    ProjectTemplateWorkflowSettingsAssignedToDto,
)
from phrasetms_client.models.project_term_base_dto import ProjectTermBaseDto
from phrasetms_client.models.project_term_base_list_dto import ProjectTermBaseListDto
from phrasetms_client.models.project_term_base_reference import ProjectTermBaseReference
from phrasetms_client.models.project_trans_memory_dto_v3 import ProjectTransMemoryDtoV3
from phrasetms_client.models.project_trans_memory_list_dto_v3 import (
    ProjectTransMemoryListDtoV3,
)
from phrasetms_client.models.project_translation_memory_reference import (
    ProjectTranslationMemoryReference,
)
from phrasetms_client.models.project_workflow_step_dto import ProjectWorkflowStepDto
from phrasetms_client.models.project_workflow_step_dto_v2 import (
    ProjectWorkflowStepDtoV2,
)
from phrasetms_client.models.project_workflow_step_list_dto_v2 import (
    ProjectWorkflowStepListDtoV2,
)
from phrasetms_client.models.project_workflow_step_reference import (
    ProjectWorkflowStepReference,
)
from phrasetms_client.models.properties_settings_dto import PropertiesSettingsDto
from phrasetms_client.models.provider_list_dto_v2 import ProviderListDtoV2
from phrasetms_client.models.provider_reference import ProviderReference
from phrasetms_client.models.providers import Providers
from phrasetms_client.models.providers_per_language import ProvidersPerLanguage
from phrasetms_client.models.psd_settings_dto import PsdSettingsDto
from phrasetms_client.models.pseudo_translate_action_dto import PseudoTranslateActionDto
from phrasetms_client.models.pseudo_translate_action_dto_v2 import (
    PseudoTranslateActionDtoV2,
)
from phrasetms_client.models.pseudo_translate_wrapper_dto import (
    PseudoTranslateWrapperDto,
)
from phrasetms_client.models.qa_check_dto_v2 import QACheckDtoV2
from phrasetms_client.models.qa_settings_dto_v2 import QASettingsDtoV2
from phrasetms_client.models.quality_assurance_batch_run_dto_v3 import (
    QualityAssuranceBatchRunDtoV3,
)
from phrasetms_client.models.quality_assurance_checks_dto_v2 import (
    QualityAssuranceChecksDtoV2,
)
from phrasetms_client.models.quality_assurance_dto import QualityAssuranceDto
from phrasetms_client.models.quality_assurance_response_dto import (
    QualityAssuranceResponseDto,
)
from phrasetms_client.models.quality_assurance_run_dto_v3 import (
    QualityAssuranceRunDtoV3,
)
from phrasetms_client.models.quality_assurance_segments_run_dto_v3 import (
    QualityAssuranceSegmentsRunDtoV3,
)
from phrasetms_client.models.quark_tag_settings_dto import QuarkTagSettingsDto
from phrasetms_client.models.query import Query
from phrasetms_client.models.quote_create_v2_dto import QuoteCreateV2Dto
from phrasetms_client.models.quote_dto import QuoteDto
from phrasetms_client.models.quote_units_dto import QuoteUnitsDto
from phrasetms_client.models.quote_v2_dto import QuoteV2Dto
from phrasetms_client.models.quote_workflow_setting_dto import QuoteWorkflowSettingDto
from phrasetms_client.models.regex import REGEX
from phrasetms_client.models.regex_all_of import REGEXAllOf
from phrasetms_client.models.reference_correlation import ReferenceCorrelation
from phrasetms_client.models.reference_file_access_dto import ReferenceFileAccessDto
from phrasetms_client.models.reference_file_page_dto import ReferenceFilePageDto
from phrasetms_client.models.reference_file_reference import ReferenceFileReference
from phrasetms_client.models.regexp_check_rule_dto_v2 import RegexpCheckRuleDtoV2
from phrasetms_client.models.relative_translation_length_warning_dto import (
    RelativeTranslationLengthWarningDto,
)
from phrasetms_client.models.remote_uploaded_file_dto import RemoteUploadedFileDto
from phrasetms_client.models.repeated_word_warning_dto import RepeatedWordWarningDto
from phrasetms_client.models.repeated_word_warning_dto_all_of import (
    RepeatedWordWarningDtoAllOf,
)
from phrasetms_client.models.repeated_words_warning_dto import RepeatedWordsWarningDto
from phrasetms_client.models.repeated_words_warning_dto_all_of import (
    RepeatedWordsWarningDtoAllOf,
)
from phrasetms_client.models.repetitions_settings_dto import RepetitionsSettingsDto
from phrasetms_client.models.replay_request_dto import ReplayRequestDto
from phrasetms_client.models.response import Response
from phrasetms_client.models.resx_settings_dto import ResxSettingsDto
from phrasetms_client.models.segmenttarget import SEGMENTTARGET
from phrasetms_client.models.segmenttarget_all_of import SEGMENTTARGETAllOf
from phrasetms_client.models.string import STRING
from phrasetms_client.models.string_all_of import STRINGAllOf
from phrasetms_client.models.submitter import SUBMITTER
from phrasetms_client.models.submitter_all_of import SUBMITTERAllOf
from phrasetms_client.models.submitteredit import SUBMITTEREDIT
from phrasetms_client.models.submitteredit_all_of import SUBMITTEREDITAllOf
from phrasetms_client.models.submitterresponse import SUBMITTERRESPONSE
from phrasetms_client.models.submitterresponse_all_of import SUBMITTERRESPONSEAllOf
from phrasetms_client.models.schema_extension import SchemaExtension
from phrasetms_client.models.scim_meta import ScimMeta
from phrasetms_client.models.scim_resource_schema import ScimResourceSchema
from phrasetms_client.models.scim_resource_type_schema import ScimResourceTypeSchema
from phrasetms_client.models.scim_user_core_dto import ScimUserCoreDto
from phrasetms_client.models.sdl_xlf_settings_dto import SdlXlfSettingsDto
from phrasetms_client.models.search_in_text_response2_dto import (
    SearchInTextResponse2Dto,
)
from phrasetms_client.models.search_in_text_response_list2_dto import (
    SearchInTextResponseList2Dto,
)
from phrasetms_client.models.search_jobs_dto import SearchJobsDto
from phrasetms_client.models.search_jobs_request_dto import SearchJobsRequestDto
from phrasetms_client.models.search_request_dto import SearchRequestDto
from phrasetms_client.models.search_response_list_tb_dto import SearchResponseListTbDto
from phrasetms_client.models.search_response_list_tm_dto import SearchResponseListTmDto
from phrasetms_client.models.search_response_list_tm_dto_v3 import (
    SearchResponseListTmDtoV3,
)
from phrasetms_client.models.search_response_tb_dto import SearchResponseTbDto
from phrasetms_client.models.search_tmby_job_request_dto import SearchTMByJobRequestDto
from phrasetms_client.models.search_tmby_job_request_dto_v3 import (
    SearchTMByJobRequestDtoV3,
)
from phrasetms_client.models.search_tm_client_dto import SearchTMClientDto
from phrasetms_client.models.search_tm_client_dto_v3 import SearchTMClientDtoV3
from phrasetms_client.models.search_tm_domain_dto import SearchTMDomainDto
from phrasetms_client.models.search_tm_domain_dto_v3 import SearchTMDomainDtoV3
from phrasetms_client.models.search_tm_project_dto import SearchTMProjectDto
from phrasetms_client.models.search_tm_project_dto_v3 import SearchTMProjectDtoV3
from phrasetms_client.models.search_tm_request_dto import SearchTMRequestDto
from phrasetms_client.models.search_tm_response_dto import SearchTMResponseDto
from phrasetms_client.models.search_tm_response_dto_v3 import SearchTMResponseDtoV3
from phrasetms_client.models.search_tm_segment_dto import SearchTMSegmentDto
from phrasetms_client.models.search_tm_segment_dto_v3 import SearchTMSegmentDtoV3
from phrasetms_client.models.search_tm_sub_domain_dto import SearchTMSubDomainDto
from phrasetms_client.models.search_tm_sub_domain_dto_v3 import SearchTMSubDomainDtoV3
from phrasetms_client.models.search_tm_trans_memory_dto import SearchTMTransMemoryDto
from phrasetms_client.models.search_tm_trans_memory_dto_v3 import (
    SearchTMTransMemoryDtoV3,
)
from phrasetms_client.models.search_tb_by_job_request_dto import SearchTbByJobRequestDto
from phrasetms_client.models.search_tb_in_text_by_job_request_dto import (
    SearchTbInTextByJobRequestDto,
)
from phrasetms_client.models.search_tb_response_dto import SearchTbResponseDto
from phrasetms_client.models.search_tb_response_list_dto import SearchTbResponseListDto
from phrasetms_client.models.seg_rule_reference import SegRuleReference
from phrasetms_client.models.segment_dto import SegmentDto
from phrasetms_client.models.segment_list_dto import SegmentListDto
from phrasetms_client.models.segment_reference import SegmentReference
from phrasetms_client.models.segment_warning import SegmentWarning
from phrasetms_client.models.segment_warnings_dto import SegmentWarningsDto
from phrasetms_client.models.segmentation_rule_dto import SegmentationRuleDto
from phrasetms_client.models.segmentation_rule_reference import (
    SegmentationRuleReference,
)
from phrasetms_client.models.segments_counts_dto import SegmentsCountsDto
from phrasetms_client.models.segments_counts_response_dto import (
    SegmentsCountsResponseDto,
)
from phrasetms_client.models.segments_counts_response_list_dto import (
    SegmentsCountsResponseListDto,
)
from phrasetms_client.models.service_provider_config_dto import ServiceProviderConfigDto
from phrasetms_client.models.set_context_pt_trans_memories_v2_dto import (
    SetContextPTTransMemoriesV2Dto,
)
from phrasetms_client.models.set_context_trans_memories_dto_v3_dto import (
    SetContextTransMemoriesDtoV3Dto,
)
from phrasetms_client.models.set_financial_settings_dto import SetFinancialSettingsDto
from phrasetms_client.models.set_project_status_dto import SetProjectStatusDto
from phrasetms_client.models.set_project_template_term_base_dto import (
    SetProjectTemplateTermBaseDto,
)
from phrasetms_client.models.set_project_template_trans_memories_v2_dto import (
    SetProjectTemplateTransMemoriesV2Dto,
)
from phrasetms_client.models.set_project_template_trans_memory_v2_dto import (
    SetProjectTemplateTransMemoryV2Dto,
)
from phrasetms_client.models.set_project_trans_memories_v3_dto import (
    SetProjectTransMemoriesV3Dto,
)
from phrasetms_client.models.set_project_trans_memory_v3_dto import (
    SetProjectTransMemoryV3Dto,
)
from phrasetms_client.models.set_term_base_dto import SetTermBaseDto
from phrasetms_client.models.severity_dto import SeverityDto
from phrasetms_client.models.sftp import Sftp
from phrasetms_client.models.sftp_all_of import SftpAllOf
from phrasetms_client.models.sitecore import Sitecore
from phrasetms_client.models.sitecore_all_of import SitecoreAllOf
from phrasetms_client.models.source_target_regexp_warning_dto import (
    SourceTargetRegexpWarningDto,
)
from phrasetms_client.models.source_target_regexp_warning_dto_all_of import (
    SourceTargetRegexpWarningDtoAllOf,
)
from phrasetms_client.models.spell_check_request_dto import SpellCheckRequestDto
from phrasetms_client.models.spell_check_response_dto import SpellCheckResponseDto
from phrasetms_client.models.spell_check_warning_dto import SpellCheckWarningDto
from phrasetms_client.models.spell_check_warning_dto_all_of import (
    SpellCheckWarningDtoAllOf,
)
from phrasetms_client.models.split_job_action_dto import SplitJobActionDto
from phrasetms_client.models.status_dto import StatusDto
from phrasetms_client.models.style_weights_dto import StyleWeightsDto
from phrasetms_client.models.sub_domain_dto import SubDomainDto
from phrasetms_client.models.sub_domain_edit_dto import SubDomainEditDto
from phrasetms_client.models.sub_domain_reference import SubDomainReference
from phrasetms_client.models.substitute_dto import SubstituteDto
from phrasetms_client.models.substitute_dto_v2 import SubstituteDtoV2
from phrasetms_client.models.suggest_request_dto import SuggestRequestDto
from phrasetms_client.models.suggest_response import SuggestResponse
from phrasetms_client.models.suggest_response_dto import SuggestResponseDto
from phrasetms_client.models.suggestion import Suggestion
from phrasetms_client.models.supported import Supported
from phrasetms_client.models.tm_match_settings_dto import TMMatchSettingsDto
from phrasetms_client.models.tag_metadata import TagMetadata
from phrasetms_client.models.tag_metadata_dto import TagMetadataDto
from phrasetms_client.models.target_file_warnings_dto import TargetFileWarningsDto
from phrasetms_client.models.target_language_dto import TargetLanguageDto
from phrasetms_client.models.target_source_identical_warning_dto import (
    TargetSourceIdenticalWarningDto,
)
from phrasetms_client.models.task_mapping_dto import TaskMappingDto
from phrasetms_client.models.term import Term
from phrasetms_client.models.term_base_dto import TermBaseDto
from phrasetms_client.models.term_base_edit_dto import TermBaseEditDto
from phrasetms_client.models.term_base_reference import TermBaseReference
from phrasetms_client.models.term_base_search_request_dto import (
    TermBaseSearchRequestDto,
)
from phrasetms_client.models.term_create_by_job_dto import TermCreateByJobDto
from phrasetms_client.models.term_create_dto import TermCreateDto
from phrasetms_client.models.term_dto import TermDto
from phrasetms_client.models.term_edit_dto import TermEditDto
from phrasetms_client.models.term_pair_dto import TermPairDto
from phrasetms_client.models.term_v2_dto import TermV2Dto
from phrasetms_client.models.terminology_warning_dto import TerminologyWarningDto
from phrasetms_client.models.terminology_warning_dto_all_of import (
    TerminologyWarningDtoAllOf,
)
from phrasetms_client.models.terminology_weights_dto import TerminologyWeightsDto
from phrasetms_client.models.toggleable_weight_dto import ToggleableWeightDto
from phrasetms_client.models.trailing_punctuation_warning_dto import (
    TrailingPunctuationWarningDto,
)
from phrasetms_client.models.trailing_punctuation_warning_dto_all_of import (
    TrailingPunctuationWarningDtoAllOf,
)
from phrasetms_client.models.trailing_space_warning_dto import TrailingSpaceWarningDto
from phrasetms_client.models.trans_memory_create_dto import TransMemoryCreateDto
from phrasetms_client.models.trans_memory_dto import TransMemoryDto
from phrasetms_client.models.trans_memory_dto_v2 import TransMemoryDtoV2
from phrasetms_client.models.trans_memory_dto_v3 import TransMemoryDtoV3
from phrasetms_client.models.trans_memory_edit_dto import TransMemoryEditDto
from phrasetms_client.models.trans_memory_reference_dto_v2 import (
    TransMemoryReferenceDtoV2,
)
from phrasetms_client.models.translation_dto import TranslationDto
from phrasetms_client.models.translation_length_warning_dto import (
    TranslationLengthWarningDto,
)
from phrasetms_client.models.translation_memory_settings_dto import (
    TranslationMemorySettingsDto,
)
from phrasetms_client.models.translation_price_dto import TranslationPriceDto
from phrasetms_client.models.translation_price_list_create_dto import (
    TranslationPriceListCreateDto,
)
from phrasetms_client.models.translation_price_list_dto import TranslationPriceListDto
from phrasetms_client.models.translation_price_set_bulk_delete_dto import (
    TranslationPriceSetBulkDeleteDto,
)
from phrasetms_client.models.translation_price_set_bulk_minimum_prices_dto import (
    TranslationPriceSetBulkMinimumPricesDto,
)
from phrasetms_client.models.translation_price_set_bulk_prices_dto import (
    TranslationPriceSetBulkPricesDto,
)
from phrasetms_client.models.translation_price_set_create_dto import (
    TranslationPriceSetCreateDto,
)
from phrasetms_client.models.translation_price_set_dto import TranslationPriceSetDto
from phrasetms_client.models.translation_price_set_list_dto import (
    TranslationPriceSetListDto,
)
from phrasetms_client.models.translation_request_dto import TranslationRequestDto
from phrasetms_client.models.translation_request_extended_dto import (
    TranslationRequestExtendedDto,
)
from phrasetms_client.models.translation_resources_dto import TranslationResourcesDto
from phrasetms_client.models.translation_segments_reference_v2 import (
    TranslationSegmentsReferenceV2,
)
from phrasetms_client.models.tridion import Tridion
from phrasetms_client.models.ttx_settings_dto import TtxSettingsDto
from phrasetms_client.models.txt_settings_dto import TxtSettingsDto
from phrasetms_client.models.types_dto import TypesDto
from phrasetms_client.models.typo3 import Typo3
from phrasetms_client.models.typo3_all_of import Typo3AllOf
from phrasetms_client.models.user_ import USER
from phrasetms_client.models.user__all_of import USERAllOf
from phrasetms_client.models.uid_reference import UidReference
from phrasetms_client.models.unmodified_fuzzy_translation_mtnt_warning_dto import (
    UnmodifiedFuzzyTranslationMTNTWarningDto,
)
from phrasetms_client.models.unmodified_fuzzy_translation_mtnt_warning_dto_all_of import (
    UnmodifiedFuzzyTranslationMTNTWarningDtoAllOf,
)
from phrasetms_client.models.unmodified_fuzzy_translation_tm_warning_dto import (
    UnmodifiedFuzzyTranslationTMWarningDto,
)
from phrasetms_client.models.unmodified_fuzzy_translation_warning_dto import (
    UnmodifiedFuzzyTranslationWarningDto,
)
from phrasetms_client.models.unresolved_comment_warning_dto import (
    UnresolvedCommentWarningDto,
)
from phrasetms_client.models.unresolved_conversation_warning_dto import (
    UnresolvedConversationWarningDto,
)
from phrasetms_client.models.update_custom_field_instance_dto import (
    UpdateCustomFieldInstanceDto,
)
from phrasetms_client.models.update_custom_field_instance_with_uid_dto import (
    UpdateCustomFieldInstanceWithUidDto,
)
from phrasetms_client.models.update_custom_field_instances_dto import (
    UpdateCustomFieldInstancesDto,
)
from phrasetms_client.models.update_custom_file_type_dto import UpdateCustomFileTypeDto
from phrasetms_client.models.update_ignored_checks_dto import UpdateIgnoredChecksDto
from phrasetms_client.models.update_ignored_job_part_segment import (
    UpdateIgnoredJobPartSegment,
)
from phrasetms_client.models.update_ignored_segment import UpdateIgnoredSegment
from phrasetms_client.models.update_ignored_warning import UpdateIgnoredWarning
from phrasetms_client.models.update_ignored_warnings_dto import UpdateIgnoredWarningsDto
from phrasetms_client.models.update_lqa_profile_dto import UpdateLqaProfileDto
from phrasetms_client.models.upload_result_dto import UploadResultDto
from phrasetms_client.models.uploaded_file_dto import UploadedFileDto
from phrasetms_client.models.user import User
from phrasetms_client.models.user_details_dto_v3 import UserDetailsDtoV3
from phrasetms_client.models.user_dto import UserDto
from phrasetms_client.models.user_password_edit_dto import UserPasswordEditDto
from phrasetms_client.models.user_reference import UserReference
from phrasetms_client.models.user_references_dto import UserReferencesDto
from phrasetms_client.models.user_statistics_dto import UserStatisticsDto
from phrasetms_client.models.user_statistics_list_dto import UserStatisticsListDto
from phrasetms_client.models.vendor_ import VENDOR
from phrasetms_client.models.vendor__all_of import VENDORAllOf
from phrasetms_client.models.void import VOID
from phrasetms_client.models.void_all_of import VOIDAllOf
from phrasetms_client.models.variable_dto import VariableDto
from phrasetms_client.models.vendor import Vendor
from phrasetms_client.models.vendor_all_of import VendorAllOf
from phrasetms_client.models.vendor_dto import VendorDto
from phrasetms_client.models.vendor_reference import VendorReference
from phrasetms_client.models.vendor_security_settings_dto import (
    VendorSecuritySettingsDto,
)
from phrasetms_client.models.vendor_user_reference import VendorUserReference
from phrasetms_client.models.verity_weights_dto import VerityWeightsDto
from phrasetms_client.models.web_editor_link_dto_v2 import WebEditorLinkDtoV2
from phrasetms_client.models.web_hook_dto_v2 import WebHookDtoV2
from phrasetms_client.models.webhook_call_dto import WebhookCallDto
from phrasetms_client.models.webhook_preview_dto import WebhookPreviewDto
from phrasetms_client.models.webhook_previews_dto import WebhookPreviewsDto
from phrasetms_client.models.wild_card_search_by_job_request_dto_v3 import (
    WildCardSearchByJobRequestDtoV3,
)
from phrasetms_client.models.wild_card_search_request_dto import (
    WildCardSearchRequestDto,
)
from phrasetms_client.models.wordpress import Wordpress
from phrasetms_client.models.wordpress_all_of import WordpressAllOf
from phrasetms_client.models.workflow_changes_dto import WorkflowChangesDto
from phrasetms_client.models.workflow_step_configuration import (
    WorkflowStepConfiguration,
)
from phrasetms_client.models.workflow_step_dto import WorkflowStepDto
from phrasetms_client.models.workflow_step_reference import WorkflowStepReference
from phrasetms_client.models.workflow_step_reference_v2 import WorkflowStepReferenceV2
from phrasetms_client.models.workflow_step_reference_v3 import WorkflowStepReferenceV3
from phrasetms_client.models.workflow_step_settings_dto import WorkflowStepSettingsDto
from phrasetms_client.models.workflow_step_settings_edit_dto import (
    WorkflowStepSettingsEditDto,
)
from phrasetms_client.models.xlf2_settings_dto import Xlf2SettingsDto
from phrasetms_client.models.xlf_settings_dto import XlfSettingsDto
from phrasetms_client.models.xls_settings_dto import XlsSettingsDto
from phrasetms_client.models.xml_settings_dto import XmlSettingsDto
from phrasetms_client.models.yaml_settings_dto import YamlSettingsDto
