# coding: utf-8

"""
    Phrase TMS API

    Welcome to Phrase's TMS API documentation.    Please visit our [help center](https://support.phrase.com/hc/en-us/sections/5709662083612) for more information about the APIs.    If you have any questions, please contact [Support](https://support.phrase.com/hc/requests/new).    Please, include the `User-Agent` header with the name of your application or project. It might be a good idea to include some sort of contact information as well, so that we can get in touch if necessary. Examples of excellent `User-Agent` headers:  > User-Agent: Example mobile app (example@phrase.com) <br/> User-Agent: ACME Inc Java 1.8 Client (http://acmeinc.com/contact)  # noqa: E501

    The version of the OpenAPI document: Latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist, constr
from phrasetms_client.models.id_reference import IdReference

class CreateProjectFromTemplateV2Dto(BaseModel):
    """
    CreateProjectFromTemplateV2Dto
    """
    name: constr(strict=True, max_length=255, min_length=0) = Field(...)
    source_lang: Optional[StrictStr] = Field(None, alias="sourceLang")
    target_langs: Optional[conlist(StrictStr)] = Field(None, alias="targetLangs")
    workflow_steps: Optional[conlist(IdReference)] = Field(None, alias="workflowSteps")
    date_due: Optional[datetime] = Field(None, alias="dateDue")
    note: Optional[StrictStr] = None
    client: Optional[IdReference] = None
    business_unit: Optional[IdReference] = Field(None, alias="businessUnit")
    domain: Optional[IdReference] = None
    sub_domain: Optional[IdReference] = Field(None, alias="subDomain")
    cost_center: Optional[IdReference] = Field(None, alias="costCenter")
    __properties = ["name", "sourceLang", "targetLangs", "workflowSteps", "dateDue", "note", "client", "businessUnit", "domain", "subDomain", "costCenter"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateProjectFromTemplateV2Dto:
        """Create an instance of CreateProjectFromTemplateV2Dto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in workflow_steps (list)
        _items = []
        if self.workflow_steps:
            for _item in self.workflow_steps:
                if _item:
                    _items.append(_item.to_dict())
            _dict['workflowSteps'] = _items
        # override the default output from pydantic by calling `to_dict()` of client
        if self.client:
            _dict['client'] = self.client.to_dict()
        # override the default output from pydantic by calling `to_dict()` of business_unit
        if self.business_unit:
            _dict['businessUnit'] = self.business_unit.to_dict()
        # override the default output from pydantic by calling `to_dict()` of domain
        if self.domain:
            _dict['domain'] = self.domain.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sub_domain
        if self.sub_domain:
            _dict['subDomain'] = self.sub_domain.to_dict()
        # override the default output from pydantic by calling `to_dict()` of cost_center
        if self.cost_center:
            _dict['costCenter'] = self.cost_center.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateProjectFromTemplateV2Dto:
        """Create an instance of CreateProjectFromTemplateV2Dto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateProjectFromTemplateV2Dto.parse_obj(obj)

        _obj = CreateProjectFromTemplateV2Dto.parse_obj({
            "name": obj.get("name"),
            "source_lang": obj.get("sourceLang"),
            "target_langs": obj.get("targetLangs"),
            "workflow_steps": [IdReference.from_dict(_item) for _item in obj.get("workflowSteps")] if obj.get("workflowSteps") is not None else None,
            "date_due": obj.get("dateDue"),
            "note": obj.get("note"),
            "client": IdReference.from_dict(obj.get("client")) if obj.get("client") is not None else None,
            "business_unit": IdReference.from_dict(obj.get("businessUnit")) if obj.get("businessUnit") is not None else None,
            "domain": IdReference.from_dict(obj.get("domain")) if obj.get("domain") is not None else None,
            "sub_domain": IdReference.from_dict(obj.get("subDomain")) if obj.get("subDomain") is not None else None,
            "cost_center": IdReference.from_dict(obj.get("costCenter")) if obj.get("costCenter") is not None else None
        })
        return _obj

