# coding: utf-8

"""
    Phrase TMS API

    Welcome to Phrase's TMS API documentation.    Please visit our [help center](https://support.phrase.com/hc/en-us/sections/5709662083612) for more information about the APIs.    If you have any questions, please contact [Support](https://support.phrase.com/hc/requests/new).    Please, include the `User-Agent` header with the name of your application or project. It might be a good idea to include some sort of contact information as well, so that we can get in touch if necessary. Examples of excellent `User-Agent` headers:  > User-Agent: Example mobile app (example@phrase.com) <br/> User-Agent: ACME Inc Java 1.8 Client (http://acmeinc.com/contact)  # noqa: E501

    The version of the OpenAPI document: Latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from phrasetms_client.models.tag_metadata_dto import TagMetadataDto

class SegmentDto(BaseModel):
    """
    SegmentDto
    """
    target_lang: StrictStr = Field(..., alias="targetLang")
    source_segment: StrictStr = Field(..., alias="sourceSegment")
    target_segment: StrictStr = Field(..., alias="targetSegment")
    previous_source_segment: Optional[StrictStr] = Field(None, alias="previousSourceSegment")
    next_source_segment: Optional[StrictStr] = Field(None, alias="nextSourceSegment")
    source_tag_metadata: Optional[conlist(TagMetadataDto)] = Field(None, alias="sourceTagMetadata")
    target_tag_metadata: Optional[conlist(TagMetadataDto)] = Field(None, alias="targetTagMetadata")
    __properties = ["targetLang", "sourceSegment", "targetSegment", "previousSourceSegment", "nextSourceSegment", "sourceTagMetadata", "targetTagMetadata"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SegmentDto:
        """Create an instance of SegmentDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in source_tag_metadata (list)
        _items = []
        if self.source_tag_metadata:
            for _item in self.source_tag_metadata:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sourceTagMetadata'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in target_tag_metadata (list)
        _items = []
        if self.target_tag_metadata:
            for _item in self.target_tag_metadata:
                if _item:
                    _items.append(_item.to_dict())
            _dict['targetTagMetadata'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SegmentDto:
        """Create an instance of SegmentDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SegmentDto.parse_obj(obj)

        _obj = SegmentDto.parse_obj({
            "target_lang": obj.get("targetLang"),
            "source_segment": obj.get("sourceSegment"),
            "target_segment": obj.get("targetSegment"),
            "previous_source_segment": obj.get("previousSourceSegment"),
            "next_source_segment": obj.get("nextSourceSegment"),
            "source_tag_metadata": [TagMetadataDto.from_dict(_item) for _item in obj.get("sourceTagMetadata")] if obj.get("sourceTagMetadata") is not None else None,
            "target_tag_metadata": [TagMetadataDto.from_dict(_item) for _item in obj.get("targetTagMetadata")] if obj.get("targetTagMetadata") is not None else None
        })
        return _obj

